
# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                          IMPORTS ET DONNÉES GÉNÉRALES COMMUNES                                          **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

import IPython.display as display

# liste des messages d'aide, un dictionnaire de messages par question
tab_aide = []

# liste des messages de vérification, un dictionnaire de messages par question
tab_verif = []


# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                                    DONNÉES DE L'ACTIVITÉ                                              **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

# écrire ici si nécessaire les données spécifiques à l'activité
    
# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                  MESSSAGES À AFFICHER POUR LES AIDES ET LES VERIFICATIONS                               **
# **                                                    (A MODIFIER)                                                         **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

dico_aide = {'question' : 1,

1 :
"""
!!! tip Aide n°1
la réponse que vous cherchez est : 'eureka'
.Mais testez d'aabord les réponses suivantes :
- euréka
- Eureka
-'eureca', 'eurequa'

Saisir ici le message à afficher pour l'aide n°1 de la question 1.
!!!
""",

2 :
"""
!!! tip Aide n°2
Saisir ici le message à afficher pour l'aide n°2 de la question 1.
!!!
"""
}

dico_verif = {'question' : 1, 'solution' : ['eureka', 'Eureka'],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
Bravo, la réponse est bien `eureka` ou `Eureka`.

écrire ici le commentaire à afficher en cas de réponse correcte
!!!
!!! note Remarque
On peut ajouter d'autres commentaires
!!!
""",

              
'code_type' :
"""
!!! warning Attention
écrire ici le commentaire à afficher en cas d'erreur sur le type de la réponse attendue
!!!
""",

        
'code_faux' :
"""
!!! failure Faux
écrire ici le commentaire à afficher par défaut en cas de réponse incorrecte
!!!
""",
              
# vérifications personnalisées
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée
              
"""
#0
global retour
retour = False
if 'é' in reponse:
    retour = True
""" :
"""
!!! warning Attention
pas d'accent SVP (erreur non pénalisée)
!!!
""",
              

"""
#1
global retour
retour = False
if reponse in ['eureca', 'eurequa']:
    retour = True
""" :
"""
!!! warning Attention
Attention à l'orthographe (erreur pénalisée)
!!!
""",
                              
}
                
tab_verif.append(dico_verif)
tab_aide.append(dico_aide)

# ------------------------------------------------------------------------------------------- EXERCICE 1 question 2

dico_aide = {'question' : 2,

1 :
"""
!!! tip Aide n°1
la réponse que vous cherchez est : `42`

Saisir ici le message à afficher pour l'aide n°1 de la question 2.
!!!
""",

2 :
"""
!!! tip Aide n°2
Saisir ici le message à afficher pour l'aide n°2 de la question 2.
!!!
"""
}

dico_verif = {'question' : 2, 'solution' : [42],

# vérifications par defaut
              
'code_correct' :
"""
!!! success Correct
La réponse est à la Grande Question est bien 42
!!!
""",

'code_type' :
"""
!!! warning Attention
La réponse saisie doit être de type `int`
!!!
""",

'code_faux' :
"""
!!! failure Faux
Mauvaise réponse
!!!
""",
              
# vérifications personnalisées
# en-tête #0 -> erreur non décomptée
# en-tête #1 -> erreur décomptée
# variable <retour>: vaut True si erreur avérée
   
}
                
tab_verif.append(dico_verif)
tab_aide.append(dico_aide)

# ---------------------------------------------------------------------------------------------------------------- EXERCICE 2
# ------------------------------------------------------------------------------------------- EXERCICE 2 question 3

dico_aide = {'question' : 3,

1 :
"""
!!! tip Aide n°1
Pour chaque dictionnaire de la liste `objets`, 
il faut ajouter la valeur de la clé `'Nom'` à la liste qui doit être renvoyée.
!!!
""",

2 :    
"""
!!! tip Aide n°2
- Parcourir la liste de dictionnaires avec une boucle for.
- Dans le corps de la boucle, on ajoute la valeur de la clé `'Nom'` à la liste qui doit être renvoyée.
!!!
""",

3 :    
"""
!!! tip Aide n°3
Les lignes suivantes doivent apparaître et sont à compléter :

```python
  
for objet in ... :
    ...append(objet...)
```
!!!
""",

4 :
"""
!!! tip Aide n°4
**Voici un pseudo-code:**

```
L <- liste vide
Pour chaque dictionnaire objet de la liste objets
Faire
    L <- ajouter le nom de l'objet
fin Pour
```
!!!
""",

5 :    
"""<iframe src="https://www.codepuzzle.io/IPYWFQ" width="100%" height="600" frameborder="0"></iframe>"""
}

tab_aide.append(dico_aide)



# FIN DES MESSAGES




# FIN DES MESSAGES

# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                     FONCTIONS GÉNÉRALES (NE PAS MODIFIER)                                               **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

# ------------------------- création du tableau de résultats

def creer_tab_resultats(tab_aide):
    resultats = []
    i = 0
    for dico in tab_aide :
        resultats.append({})
        resultats[i]["question"] = dico['question']
        resultats[i]["aides disponibles"] = len(dico)- 1
        resultats[i]["aides utilisées"] = []
        resultats[i]["échecs"] = 0
        resultats[i]["validée"] = 0
        i += 1
    def tri(resultats):
        return resultats['question']
    return sorted(resultats, key = tri)

resultats = creer_tab_resultats(tab_aide)

# ----------------------- écrire les résultats dans un fichier .csv

def write_resultats():
    f = open("resultats.csv", "w")
    f.write("question;aides disponibles;aides utilisées;échecs;validée\n")
    for _ in resultats:  
        f.write(str(_["question"]) + ";" + str(_["aides disponibles"]) + ";" + str(_["aides utilisées"]) + ";" + str(_["échecs"])+ ";" + str(_["validée"])+"\n")
    f.close()

# ------------------ afficher les résultats dans un tableau markdown

def tableau_resultats():
    table = "|"
    for entete in resultats[0].keys():
        table += entete
        table += "|"

    table += "\n|"

    for i in range(len(resultats[0])):
        table += ":-:|"

    table += "\n"

    for i in range(len(resultats)):
        table += "|"
        for data in resultats[i].values():
            table += str(data)
            table += "|"
        table += "\n"
    return display.Markdown(table)
    
# -------------------------- affichage des aides + remplissage tableau resultat
# les aides et les échecs ne sont pas décomptés si la question a déjà été validée

# ---------- message affiché lorsque les aides
# ne sont pas demandées progressivement dans l'ordre
ordre = """
!!! bug Ordre des aides
Utilisez d'abord les aides précédentes avant de demander celle-ci.
!!!
"""

# ---------- message affiché lorsque les aides sont épuisées pour une question
fini = """
!!! bug Numéro indisponible
Il n'y a pas d'aide correspondant à ce numéro.
!!!
"""

def aide(q,n):

    # numéro de la question -> accès au dico aide
    for dico_aide in tab_aide:
        if dico_aide['question'] == q:
            break

    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break        

    if n in dico_aide.keys() :
        if dico_resultat["validée"] == 0 :
            if n > 1 and n-1 not in dico_resultat["aides utilisées"]:
                return display.Markdown(ordre)
            if n not in dico_resultat["aides utilisées"]:
                dico_resultat["aides utilisées"].append(n)
                write_resultats()
            if '</iframe>' in dico_aide[n]:
                return display.HTML(dico_aide[n])
            else:
                return display.Markdown(dico_aide[n])
        else:
            if '</iframe>' in dico_aide[n]:
                return display.HTML(dico_aide[n])
            else:
                return display.Markdown(dico_aide[n])
    else :
        return display.Markdown(fini)


# *****************************************************************************************************************************
# *****************************************************************************************************************************
# **                                                                                                                         **
# **                                  FONCTIONS DE VÉRIFICATION (NE PAS MODIFIER)                                            **
# **                                                                                                                         **
# *****************************************************************************************************************************
# *****************************************************************************************************************************

# ------------------------ vérifications des assertions des fonctions à écrire

# ---------- message affiché lorsque le programme est validé
valide = """
!!! success Correct

!!!
"""

# ---------- message affiché si erreur assertion
assertion_err = """
!!! failure AssertionError

!!!
"""

def verif_assert(q,reponse):

    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break
    
    if 'AssertionError' in reponse :
        if dico_resultat["validée"] == 0:
            dico_resultat["échecs"] += 1
            write_resultats()
        return display.Markdown(assertion_err)    
        
    else :
        dico_resultat["validée"] = 1
        write_resultats()
        return display.Markdown(valide)

# ------------------------ vérifications des réponses (sans assertions)
  
def verif(q, reponse):
    
    # numéro de la question -> accès au dico verif
    for dico_verif in tab_verif :
        if dico_verif['question'] == q:
            break
            
    # numéro de la question -> accès au dico resultat
    for dico_resultat in resultats :
        if dico_resultat['question'] == q:
            break
            
    # -------------------------------------- erreurs non décomptées
    #(à déplacer dans la section non "erreurs décomptées" si besoin
    
    # erreur "type reponse"
    if type(reponse) != type(dico_verif['solution'][0]):
        return display.Markdown(dico_verif['code_type'])
        
    # erreur "type élément" de reponse si c'est une liste
    if type(dico_verif['solution'][0]) == list:
        for elem in reponse:
            if type (elem) != type(dico_verif['solution'][0][0]):
                return display.Markdown(dico_verif['code_type'])
                
    # erreurs non décomptées personnaliséés
    
    for test in dico_verif.keys():
            if '#0' in test :
                exec(test)
                if retour:
                    return display.Markdown(dico_verif[test])
    
    # si bonne réponse
    for sol in dico_verif['solution']:
        if sol == reponse:          
            dico_resultat["validée"] = 1
            write_resultats()
            return display.Markdown(dico_verif['code_correct'])
    
    else : 
        
        # décompte erreur
        if dico_resultat["validée"] == 0:
            dico_resultat["échecs"] += 1
            write_resultats()
            
        # erreurs décomptées personnalisées
        for test in dico_verif.keys():
            if '#1' in test :
                exec(test)
                if retour:
                    return display.Markdown(dico_verif[test])
                    
        # erreur décomptée par défaut    
        return display.Markdown(dico_verif['code_faux'])
        




